function feat = computeFeatures(im, param)
% COMPUTEFEATURES computes features for all the pixels in the image
%   FEAT = COMPUTEFEATURES(IM, PARAM) returns a [NM d] feature for an image
%   of size [N M], i.e. all the features for pixels are stacked into a
%   gigantic matrix (Use reshape() function to do this) which can be used
%   for clustering later using k-means function.
%
% This code is part of:
%
%   CMPSCI 670: Computer Vision, Fall 2014
%   University of Massachusetts, Amherst
%   Instructor: Subhransu Maji
%
%   Homework 4: Grouping and Texture

% Random features. Delete this in your code once you implement.
feat = rand([size(im,1)*size(im,2) 3]);
return;

% Compute features
switch param.feature
    case 'rgb'
        % Implement this
        % feat = ...
    case 'texton'
        % Implement this function
        feat = textons(im, param); % Compute texton features 
        feat = reshape(feat, [size(feat,1)*size(feat,2) size(feat,3)]);
end

