function [textonHist, textonId] = textons(im, param)
% TEXTONS computes a texton based representation of IM
%   [TEXTONHIST, TEXTONID] = TEXTONS(IM, PARAM) computes per-pixel texton
%   histogram and TEXTONID for image IM. If the input IM is [N M] then the
%   output TEXTONHIST is of dimension [N M D] and TEXTONID is of dimension
%   [N M]. TEXTONID is the assignment of each pixel to the one of k centers
%   found by clustering responses of the filter banks into
%   PARAM.NUMTEXTONS clusters. TEXTONHIST is the local histogram of [2*R+1
%   2*R+1] neighbourhood where R = PARAM.TEXTONHISTRADIUS. 
%   
% This code is part of:
%
%   CMPSCI 670: Computer Vision, Fall 2014
%   University of Massachusetts, Amherst
%   Instructor: Subhransu Maji
%
%   Homework 4: Grouping and Texture

% Sanity check
if size(im, 3) > 1
    im = rgb2gray(im);
end

if ~isfloat(im)
    im = im2double(im);
end


% Make filterbank
fb = makeFilterbank();
numFilters = size(fb,3);
res = cell(1, numFilters);

% Compute the response after convolutions with filters
for i = 1:numFilters,
    % Implement this
    % res{i} = ....
end

% Concatenate all the responses
res = cat(3, res{:});

% VQ the textons into numTextons clusters
numTextons = param.numTextons;

% Implement this
% textonId = ...
textonId = [];

% Collect histograms in a neighborhood of 2*R+1, R = param.textonHistRadius
% Implement this
textonHist = [];